<!DOCTYPE html>
<html>

<head>
    <title>Task 66 - Province</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid pt-5">
        <div class="row form-group">
            <div class="col-1"></div>
            <div class="col-10 form-group jumbotron" style="border-style:dashed">
                <h2 class="text-center">Tỉnh, Thành phố</h2>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="id" class="border-0 bg-transparent"><b>Id</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-id" class="form-control border-primary">
                            <option value="none">--Chọn (Trường hợp Edit và Delete)--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="province" class="border-0 bg-transparent"><b>Tỉnh, Thành</b></label>
                    </div>
                    <div class="col-8">
                        <input id="inp-province" type="text" name="province" placeholder="Add Province" class="form-control border-primary">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="code" class="border-0 bg-transparent"><b>Mã</b></label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-code" type="text" name="province-code" placeholder="Add Province Code" class="form-control border-primary">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-6"></div>
                    <div class="col-6 text-right">
                        <button class="btn btn-primary" id="add-province">Add</button>
                        <button class="btn btn-success" id="edit-province">Edit</button>
                        <button class="btn btn-danger" id="delete-province">Delete</button>
                        <button class="btn btn-light" id="cancel-province">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        onPageLoading();
        var gProvince = [];
        var gProvinceId = "";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        // gán sự kiện add cho nút Add Province
        $('#add-province').on('click', function() {
            onBtnAddProvince();
        });
        // gán sự kiện add cho nút Edit Province
        $('#edit-province').on('click', function() {
            onBtnEditProvince();
        });
        // gán sự kiện add cho nút Delete Province
        $('#delete-province').on('click', function() {
            onBtnDeleteProvince();
        });
        $('#select-id').on('change', function() {
            onBtnChangeIdSelect();
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        function onPageLoading() {
            "use strict";
            getAll()
        }

        function onBtnAddProvince() {
            "use strict";
            var vProvinceObject = {
                name: "",
                code: ""
            }
            vProvinceObject.name = $("#inp-province").val().trim();
            vProvinceObject.code = $("#inp-code").val().trim();
            $.ajax({
                async: false,
                url: "http://localhost:8080/province",
                type: "POST",
                data: JSON.stringify(vProvinceObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gProvince.push(res)
                    alert("Thêm Province thành công!");
                    loadDataIntoSelect(gProvince);
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        function onBtnEditProvince() {
            "use strict";
            console.log("nút edit được nhấn");
            var vProvinceObject = {
                name: "",
                code: ""
            }
            vProvinceObject.name = $("#inp-province").val().trim();
            vProvinceObject.code = $("#inp-code").val().trim();
            console.log(vProvinceObject);
            console.log("mã tỉnh" + gProvinceId);
            $.ajax({
                async: false,
                url: "http://localhost:8080/province/" + gProvinceId,
                type: "PUT",
                data: JSON.stringify(vProvinceObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gProvince.push(res);
                    alert("Update Province thành công!");
                    loadDataIntoSelect(gProvince);
                    $('#select-id').val("none");
                    $('#inp-province').val("");
                    $('#inp-code').val("");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        function onBtnDeleteProvince() {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/province/" + gProvinceId,
                type: "DELETE",
                data: 'json',
                success: function(res) {
                    console.log(res);
                    alert("Xóa Province thành công!");
                    $('#select-id').val("none");
                    $('#inp-province').val("");
                    $('#inp-code').val("");
                    loadDataIntoSelect(res);
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function getAll() {
            $.ajax({
                url: "http://localhost:8080/province",
                type: "GET",
                dataType: 'json',
                async: false,
                success: function(responseObject) {
                    gProvince = responseObject;
                    console.log(gProvince);
                    loadDataIntoSelect(gProvince);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        function loadDataIntoSelect(paramObject) {
            for (var bI = 0; bI < paramObject.length; bI++) {
                $('#select-id').append($('<option>', {
                    value: paramObject[bI].id,
                    text: paramObject[bI].id
                }));
            }
        }



        // Hàm xử lý khi change select id province
        function onBtnChangeIdSelect() {
            "use strict";
            gProvinceId = $("#select-id").val(); // lấy ra provinceId từ select đc chọn
            console.log("Province được chọn có Id: " + gProvinceId);
            if (gProvinceId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/province/" + gProvinceId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);
                        $('#inp-province').val(res.name);
                        $('#inp-code').val(res.code);
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            }
        }
    });
</script>

</html>